IRQ=7		; ⠢  IRQ=5, ᫨  㪮 p  IRQ5

ES1868=1	; ⠢ ES1868=0, ᫨  㪮 - ESS,  
		; ES1868  ES1869.

STEREO=1	; p/

;AY 8910/8912 emulation
;Version 1.00 beta
;Began on 5.Aug.98
;By S.Dima
;ESS chip adapted by SwordMaker.
;Stereo added by SwordMaker.

	Ideal
	p486

DMAL		=	221
IF STEREO
DMALength	=	2*220
DMABufSize	=	2*100h
RateConst	=	0EEh; 0F7h
StereoConst1	=	1
StereoConst2	=	8
ELSE
DMALength	=	220
DMABufSize	=	100h
RateConst	=	0EEh
StereoConst1	=	2
StereoConst2	=	40h
ENDIF

DSPAdr	equ	220h	;Base address of soundblaster

DSPReset	equ	06h + DSPAdr
DSPRdDat	equ	0Ah + DSPAdr
DSPWrCom	equ	0Ch + DSPAdr
DSPDtAvl	equ	0Eh + DSPAdr


	Segment Code Use16
	Assume	cs:Code, ds:Code
Nul:
	org	100h

Start:
	mov	ah,9
	mov	dx,offset HelloTxt
	int	21h
	call	MusInit
	call	BlInit
	call	SBFrq
	xor	eax,eax
	xor	ebx,ebx
	mov	ax,cs
	shl	eax,4
	mov	bx,offset DMABuf1
	add	eax,ebx
	mov	    [DMAAdr1],eax
	add	eax,DMABufSize
	mov	[DMAAdr2],eax

	cli
	xor	ax,ax
	mov	es,ax
	mov	eax,[es:(IRQ+8)*4]
	mov	[OldIntD],eax
	mov	[word ptr es:(IRQ+8)*4],offset NewIntD
	mov	[es:(IRQ+8)*4+2],cs
	sti

	xor	al,al
	call	InitDMA
	call	StartSBDMA

Wt:
	mov	ah,1
	int	16h
	jz	Wt

	xor	ah,ah
	int	16h

	jmp	Exit


MusInit:
	mov	bl,[80h]
	xor	bh,bh
	mov	[byte ptr 81h+bx],0

	mov	ax,3D00h
	mov	dx,82h
	int	21h
	jc	NoFile

	push	ax
	mov	bx,ax
	mov	cx,8000h
	mov	dx,offset MusicData
	mov	ah,3Fh
	int	21h

	pop	bx
	mov	ah,3Eh
	int	21h

	call	AyMusicInit
	ret

NoFile:
	mov	ah,9
	mov	dx,offset NoFileTxt
	int	21h
	jmp	Exit

NoFileTxt	db	'File not found ! Usage: ZXMUS1 <FileName>',13,10,'$'
HelloTxt	db	'(C) 1998 ZX-Spectrum soundtracker music player. Written by S.Dima.',13,10
		db	'Adapted for ESS1868 & stereo by SwordMaker.',13,10,'$'

CurrentDMA	db	0
DMACounter	db	0
NewIntD:
;	cli
	pusha
	push	ds es
	mov	ax,cs
	mov	ds,ax
	IF STEREO
	xor	[CurrentDMA],2
	ELSE
	xor	[CurrentDMA],1
	ENDIF
	mov	al,[CurrentDMA]
	call	InitDMA
	mov	dx,DSPDtAvl
	in	al,dx
;	sti

;Insert YOURS sound program herE

	add	[DMACounter],64
	jnz	NoNewAy
	call	AyMusicPlay
NoNewAy:
	call	AySynth

	mov	al,20h
	out	20h,al
	pop	es ds
	popa
	iret

StartSBDMA:
		mov	al,0C6h
		call	writedsp
		mov	al,0B8h
		call	writedsp
		mov	al,0
		call	writedsp
		mov	ah,0A8h
		call	read_dsp
		mov	ah,al
		mov	al,0A8h
		call	writedsp
		mov	al,ah
		and	al,0FCh
		or	al,StereoConst1
		call	writedsp
		mov	al,0B9h
		call	writedsp
		mov	al,2
		call	writedsp
		mov	al,0A1h
		call	writedsp
		mov	al,RateConst
		call	writedsp
		mov	al,0A2h
		call	writedsp
		mov	al,0FEh
		call	writedsp
		mov	cx,DMALength
		neg	cx
		mov	al,0A4h
		call	writedsp
		mov	al,cl
		call	writedsp
		mov	al,0A5h
		call	writedsp
		mov	al,ch
		call	writedsp
		mov	al,0B6h
		call	writedsp
		mov	al,80h
		call	writedsp
		mov	al,0B7h
		call	writedsp
		mov	al,51h
		call	writedsp
		mov	al,0B7h
		call	writedsp
		mov	al,090h+StereoConst2
		call	writedsp
		mov	al,0B1h
		call	read_dsp
		mov	ah,al
		mov	al,0B1h
		call	writedsp
		mov	al,ah
		and	al,0Fh
		or	al,50h
		call	writedsp
		mov	al,0B2h
		call	read_dsp
		mov	ah,al
		mov	al,0B2h
		call	writedsp
		mov	al,ah
		and	al,0Fh
		or	al,50h
		call	writedsp
		mov	al,0D1h
		call	writedsp
		IF	ES1868
		mov	dx,300h
		inc	dx
		mov	al,3Fh
		out	dx,al
		ENDIF
		mov	dx,DSPAdr
		add	dl,4
		mov	ax,4064h
		out	dx,ax
		mov	al,0B8h
		call	writedsp
		mov	al,5
		call	writedsp
	ret


SBFrq:
;44100 = 0AC44h
	in	al,21h
	mov	cl,0FEh
	rol	cl,IRQ
	and	al,cl
	out	21h,al
	ret


OldIntD dd	0
DMAAdr1 dd	0
DMAAdr2 dd	0

InitDMA:
;Initialization of the DMA
;AL = 0 for DMA1 buf and AL = 1 for DMA2 buf
	and	al,al
	mov	ebx,[DMAAdr1]
	jz	InitDMA1
	mov	ebx,[DMAAdr2]
InitDMA1:
	mov	al,5
	out	(0Ah),al
	mov	al,49h
	out	(0bh),al
	mov	al,bl
	out	(02),al
	mov	al,bh
	out	(02),al
	shr	ebx,16
	mov	al,bl
	out	(83h),al
	mov	al,DMALength and 255
	out	(03),al
	mov	al,DMALength shr 8
	out	(03),al
	mov	al,1
	out	(0Ah),al
	ret


WriteDSP:
;AL = Value to write into the DSP

	push	ax
	mov	dx,DSPWrCom
	mov	ah,al
WrDSPWt:
	in	al,dx
	and	al,80h
	jnz	WrDSPWt
	mov	al,ah
	out	dx,al
	pop	ax
	ret

read_dsp: push ax
	mov	al,0C0h
	call	writedsp
	pop	ax
	mov	al,ah
	call	writedsp
	call	readDSP
	ret

ReadDSP:
	mov	dx,DSPDtAvl
RdDSPWt:
	in	al,dx
	and	al,80h
	jz	RdDSPWt
	mov	dx,DSPRdDat
	in	al,dx
;AL = Data read from the DSP
	ret

BlInit:
	mov	dx,DSPReset
	mov	al,1
	out	dx,al
	call	BlWait
	dec	al
	out	dx,al
	call	BlWait
	mov	dx,DSPDtAvl
	in	al,dx
	and	al,80h
	jz	BlError
	mov	dx,DSPRdDat
	in	al,dx
	cmp	al,0AAh
	jnz	BlError
	ret
BlWait:
	mov	cx,30000
BlWait1:
	nop
	nop
	loop	BlWait1
	ret

BlError:
	mov	ah,9
	mov	dx,offset NoBlastTxt
	int	21h
	mov	ax,4C00h
	int	21h
Exit:
	xor	ax,ax
	mov	es,ax
	mov	eax,[OldIntD]
	mov	[es:(IRQ+8)*4],eax
	call	BlInit

	mov	ax,4C00h
	int	21h

NoBlastTxt	db	'SoundBlaster not found at 220h ...',13,10,'$'

AyRegs	db	16 dup (0);	Registers of AY

CurPosA dw	Meandr1 - Nul
ExtPosA dw	0
CurPosB dw	Meandr1 - Nul
ExtPosB dw	0
CurPosC dw	Meandr1 - Nul
ExtPosC dw	0


AySynth:
	mov	di,offset ChnlA
	mov	bx,[CurPosA]
	mov	si,[ExtPosA]
	mov	bp,[word ptr AyRegs]
	mov	ch,[byte ptr AyRegs + 7]
	and	ch,1
	call	SynthTon
	mov	[CurPosA],bx
	mov	[ExtPosA],si

	mov	di,offset ChnlB
	mov	bx,[CurPosB]
	mov	si,[ExtPosB]
	mov	bp,[word ptr AyRegs + 2]
	mov	ch,[byte ptr AyRegs + 7]
	and	ch,2
	call	SynthTon
	mov	[CurPosB],bx
	mov	[ExtPosB],si

	mov	di,offset ChnlC
	mov	bx,[CurPosC]
	mov	si,[ExtPosC]
	mov	bp,[word ptr AyRegs + 4]
	mov	ch,[byte ptr AyRegs + 7]
	and	ch,4
	call	SynthTon
	mov	[CurPosC],bx
	mov	[ExtPosC],si

	call	SynthNoise
	call	SynthMod

;Here must be a sub-program for modulation emulation

	mov	al,[byte ptr AyRegs + 7]
	shr	al,4
	sbb	ah,ah
	mov	[byte ptr NoiseEA + 2],ah
	shr	al,1
	sbb	ah,ah
	mov	[byte ptr NoiseEB + 2],ah
	shr	al,1
	sbb	ah,ah
	mov	[byte ptr NoiseEC + 2],ah

	mov	al,[byte ptr AyRegs + 8]
	cmp	al,10h
	mov	ah,0Fh
	jc	Short mix01
	mov	ax,0Fh
mix01:
	mov	[byte ptr ModEA + 1],ah
	mov	[byte ptr VolA + 1],al

	mov	al,[byte ptr AyRegs + 9]
	cmp	al,10h
	mov	ah,0Fh
	jc	Short mix02
	mov	ax,0Fh
mix02:
	mov	[byte ptr ModEB + 1],ah
	mov	[byte ptr VolB + 1],al

	mov	al,[byte ptr AyRegs + 10]
	cmp	al,10h
	mov	ah,0Fh
	jc	Short mix03
	mov	ax,0Fh
mix03:
	mov	[byte ptr ModEC + 1],ah
	mov	[byte ptr VolC + 1],al

	mov	ah,[CurrentDMA]
	IF STEREO
	xor	ah,2
	xor	al,al
	ELSE
	xor	ah,1
	xor	al,al
	ENDIF
	mov	di,offset DMABuf1
	add	di,ax
	mov	si,offset ChnlA
	mov	bx,offset Volume1
	mov	cx,DMAL		;Length of buffer for 200Hz

mix1:
	push	cx
	mov	dl,[si + 1024]	;dl = noise
	mov	dh,[si + 768]	;dh = modulation

	mov	bl,dl		;bl = noise
NoiseEA:	or	bl,0		;bl = noise or bl = 1
	and	bl,[si] 	;noise + tone or tone
	mov	al,dh		;al = mod
ModEA:	or	al,0		;al = mod or al = 1
VolA:	and	al,0		;al = mod or al = volume
	and	bl,al		;full signal for channel A
	mov	ch,[bx] 	;ah - transformed signal A

	mov	bl,dl
NoiseEB:	or	bl,0
	and	bl,[si + 256]
	mov	al,dh
ModEB:	or	al,0
VolB:	and	al,0
	and	bl,al
	IF	STEREO
	mov	cl,[bx]
	add	ch,cl
	ELSE
	add	ch,[bx]
	ENDIF
	mov	bl,dl
NoiseEC:	or	bl,0
	and	bl,[si + 512]
	mov	al,dh
ModEC:	or	al,0
VolC:	and	al,0
	and	bl,al
	IF	STEREO
	add	cl,[bx]
	ELSE
	add	ch,[bx]
	ENDIF

	IF STEREO
	mov	[di],cx
	inc	di
	inc	di
	ELSE
	mov	[di],ch
	inc	di
	ENDIF
	pop	cx
	inc	si
	dec	cx
	jnz	short Mix1
	ret


SynthTon:

;DI - Destination for tone
;BX - Current position in meandr table
;SI - Extended position (virtual)
;BP - Frequency (from AY registers)
;CH = 0, tone is enabled, else tone is disabled

	cmp	ch,1
	sbb	ch,ch		;ch=0, tone enabled, 255-disabled
	xor	ch,255
	and	ebp,4095
	cmp	bp,1
	adc	bp,0
	xor	edx,edx
	mov	eax,41610159	;Constant for tone & noise
	div	ebp		;eax=shit+speed+ext.spd

	mov	bp,ax		;BP = Extended speed
	shr	eax,8		;AH = Speed
	mov	dx,DMAL		;Size of DMA buffer
Snt1:
	mov	al,[bx]
	or	al,ch
	mov	[di],al
	add	si,bp
	adc	bl,ah
	inc	di
	dec	dx
	jnz	Short Snt1

;BX - Current position in meandr table
;SI - Virtual position

	ret

CurPosN     dw	0;Noise1 - Nul
ExtPosN dw	0
SynthNoise:
	mov	ax,cs
	add	ax,(Noise1 - Nul)/16
	mov	es,ax
	mov	di,offset ChnlN
	mov	si,[ExtPosN]
	mov	bx,[CurPosN]
	mov	cl,[byte ptr AyRegs + 6]

	and	ecx,31
	cmp	cx,1
	adc	cx,0
	xor	edx,edx
	mov	eax,162540		;Constant for tone & noise
	div	ecx		;eax=shit+speed+ext.spd
	mov	dx,ax		;DX = Extended speed
	shr	eax,8		;AH = Speed
	mov	cx,DMAL		;Size of DMA buffer

Snn1:
	and	bh,07h
	mov	al,[es:bx]
;	and	al,1
;	cmp	al,1
;	sbb	al,al
	mov	[di],al
	add	si,dx
	adc	bl,ah
	adc	bh,0
	inc	di
	dec	cx
	jnz	Short Snn1

	mov	[ExtPosN],si
	mov	[CurPosN],bx
	ret


OldMMode	db	0
ExtPosM dw	0
CurPosM dw	Mod1 - Nul
ModCurAdr	dw	Mod1D - Nul

SynthMod:
	mov	bl,[byte ptr AyRegs + 13]
	cmp	bl,0FFh
	jz	Short ModS1

;	cmp	bl,[OldMMode]

;	jz	Short ModS1

;	mov	[OldMMode],bl
	mov	[byte ptr AyRegs + 13],0FFh
	xor	bh,bh
	add	bx,bx
	mov	si,[word ptr ModSel + bx]
	mov	[ModCurAdr],si
	mov	[ExtPosM],0
	mov	bh,[si]
	xor	bl,bl
	mov	[CurPosM],bx
ModS1:

	mov	cx,[word ptr AyRegs + 11]
	and	ecx,0FFFFh
	cmp	cx,1
	adc	cx,0
	xor	edx,edx
	mov	eax,2600635		;Constant for modulation
	div	ecx		;eax=shit+speed+ext.spd
	mov	bp,ax		;BP = Extended speed
	shr	eax,8		;AH = Speed

	xor	ecx,ecx
	xor	edx,edx
	mov	cx,offset ChnlM
	mov	dx,[ModCurAdr]
	mov	di,[ExtPosM]
	mov	bx,[CurPosM]

ModS2:
	mov	al,[bx]
	mov	[ecx],al
	add	di,bp		;Extended inc.
	adc	bl,ah
	jc	Short ModS3

	inc	cl
	cmp	cl,DMAL
	jnz	Short ModS2

	mov	[ExtPosM],di
	mov	[CurPosM],bx
	mov	[ModCurAdr],dx
	ret

ModS3:
; if (dx and 3) = 3 then (dx and 3):=1
; inc (dx and 3)
	mov	al,dl
	and	al,3
	cmp	al,3
	sbb	al,al
	xor	al,255
	and	al,2
	sub	dl,al
	inc	dl
	mov	bh,[edx]
	inc	cl
	jnz	Short ModS2

	mov	[ExtPosM],di
	mov	[CurPosM],bx
	mov	[ModCurAdr],dx
	ret

;The next must be at 0x00 address !!! (But how can I do it ???)

Align256	db	(256 - ((Align256 - Nul) and 255)) dup (0)

Meandr1 db	128 dup (0)	;Meandr is stored here	 Ŀ Ŀ
	db	128 dup (15);			      

Mod1	db	16 dup (0)	;Here is the first type of AY modulation:
	db	16 dup (1)	;
	db	16 dup (2)	;	  /|   /|
	db	16 dup (3)	;	 / |  / |
	db	16 dup (4)	;	/  | /	|
	db	16 dup (5)	;      /   |/	|
	db	16 dup (6)
	db	16 dup (7)
	db	16 dup (8)
	db	16 dup (9)
	db	16 dup (10)
	db	16 dup (11)
	db	16 dup (12)
	db	16 dup (13)
	db	16 dup (14)
	db	16 dup (15)

Mod2	db	16 dup (15)	;And this is the second type of AY mod.:
	db	16 dup (14)
	db	16 dup (13)	;      |\   |\
	db	16 dup (12)	;      | \  | \
	db	16 dup (11)	;      |  \ |  \
	db	16 dup (10)	;      |   \|	\
	db	16 dup (9)
	db	16 dup (8)
	db	16 dup (7)
	db	16 dup (6)
	db	16 dup (5)
	db	16 dup (4)
	db	16 dup (3)
	db	16 dup (2)
	db	16 dup (1)
	db	16 dup (0)

Mod3	db	256 dup (0)
Mod4	db	256 dup (15)

Noise1	db	 0, 0, 0,15, 0, 0,15,15
	db	15, 0, 0,15, 0, 0,15,15
	db	 0,15,15,15, 0,15, 0,15
	db	 0,15, 0,15, 0, 0,15,15
	db	15,15, 0, 0, 0,15, 0,15
	db	15,15,15,15,15,15,15, 0
	db	15, 0, 0, 0, 0,15, 0, 0
	db	15,15,15,15, 0,15, 0,15
	db	15,15, 0, 0, 0, 0, 0,15
	db	 0, 0,15,15,15,15, 0,15
	db	 0, 0,15,15,15,15,15,15
	db	15, 0, 0, 0,15, 0,15,15
	db	15,15,15,15,15,15, 0, 0
	db	15,15,15,15, 0,15, 0, 0
	db	15,15,15,15, 0,15, 0,15
	db	 0,15, 0, 0,15, 0,15, 0
	db	15,15, 0, 0,15, 0, 0,15
	db	15, 0,15,15, 0, 0, 0,15
	db	 0,15, 0,15, 0, 0,15,15
	db	 0,15,15,15, 0, 0,15,15
	db	15, 0,15,15,15,15, 0,15
	db	15,15, 0, 0,15,15,15,15
	db	15,15, 0,15,15,15, 0, 0
	db	15,15, 0,15, 0,15, 0,15
	db	15,15,15,15,15,15, 0, 0
	db	15, 0,15,15, 0,15,15, 0
	db	 0,15,15,15, 0, 0, 0,15
	db	 0, 0,15, 0,15, 0, 0, 0
	db	 0, 0,15, 0, 0, 0, 0, 0
	db	 0,15,15, 0,15,15,15,15
	db	 0,15,15, 0,15,15, 0, 0
	db	15, 0,15,15,15,15, 0, 0
	db	 0, 0, 0,15,15, 0,15,15
	db	15, 0, 0, 0, 0,15,15, 0
	db	 0, 0, 0, 0,15, 0, 0,15
	db	15,15,15, 0,15, 0,15,15
	db	 0, 0, 0,15,15,15, 0,15
	db	15, 0, 0, 0, 0,15, 0, 0
	db	15,15,15, 0, 0, 0, 0, 0
	db	 0, 0,15, 0, 0,15,15,15
	db	 0,15, 0, 0, 0, 0, 0,15
	db	15, 0, 0, 0,15,15, 0, 0
	db	 0, 0, 0, 0,15,15, 0,15
	db	 0,15,15, 0, 0, 0, 0,15
	db	15,15, 0,15,15,15, 0,15
	db	 0, 0,15, 0, 0,15, 0, 0
	db	15, 0, 0,15,15, 0,15, 0
	db	15, 0, 0, 0,15, 0,15,15
	db	 0, 0, 0,15, 0,15, 0, 0
	db	15, 0, 0,15, 0, 0, 0, 0
	db	 0, 0, 0,15, 0,15, 0,15
	db	 0,15,15,15,15,15, 0, 0
	db	 0,15, 0, 0,15,15,15,15
	db	15,15, 0,15, 0,15, 0, 0
	db	15, 0,15, 0,15, 0, 0,15
	db	 0, 0, 0, 0, 0, 0,15, 0
	db	15,15, 0, 0, 0, 0,15, 0
	db	15,15, 0,15, 0,15, 0,15
	db	 0,15,15,15, 0, 0,15, 0
	db	15, 0,15, 0,15, 0, 0, 0
	db	15,15,15, 0, 0,15, 0, 0
	db	 0,15, 0,15, 0, 0, 0, 0
	db	 0, 0,15,15,15,15, 0,15
	db	 0, 0,15,15, 0,15, 0, 0
	db	 0,15,15, 0, 0,15,15, 0
	db	 0, 0,15, 0, 0,15, 0,15
	db	15, 0,15,15, 0,15,15, 0
	db	15, 0,15, 0,15, 0,15, 0
	db	 0,15,15, 0, 0,15, 0,15
	db	 0,15,15, 0, 0,15,15,15
	db	 0, 0,15, 0, 0,15, 0,15
	db	15,15,15, 0, 0,15,15, 0
	db	15, 0, 0, 0, 0, 0, 0,15
	db	 0, 0,15,15, 0, 0,15, 0
	db	15,15, 0, 0,15,15, 0, 0
	db	 0,15,15, 0, 0,15,15,15
	db	15,15,15,15,15,15, 0,15
	db	 0, 0,15,15,15, 0, 0, 0
	db	15, 0, 0,15,15,15,15, 0
	db	15,15, 0,15,15,15,15, 0
	db	15, 0, 0, 0, 0, 0,15, 0
	db	 0,15, 0,15, 0, 0,15, 0
	db	15, 0, 0, 0, 0, 0,15,15
	db	15, 0, 0,15, 0, 0, 0, 0
	db	 0, 0,15, 0,15, 0,15,15
	db	15,15,15,15,15, 0, 0, 0
	db	15, 0,15,15, 0, 0, 0,15
	db	15,15,15, 0,15,15, 0, 0
	db	 0,15, 0, 0, 0, 0,15, 0
	db	 0,15, 0,15,15, 0,15,15
	db	15,15,15,15, 0,15,15, 0
	db	 0, 0, 0,15, 0,15, 0, 0
	db	 0, 0, 0, 0, 0,15, 0, 0
	db	 0,15,15, 0, 0,15,15,15
	db	15,15,15,15,15,15,15,15
	db	 0, 0, 0, 0,15, 0, 0, 0
	db	15, 0,15,15, 0, 0, 0, 0
	db	 0,15, 0, 0, 0, 0, 0, 0
	db	 0,15,15, 0, 0, 0,15,15
	db	15,15,15,15,15,15, 0, 0
	db	15, 0, 0, 0, 0, 0,15, 0
	db	 0,15,15,15, 0, 0, 0,15
	db	 0,15, 0, 0, 0, 0, 0,15
	db	15, 0,15, 0,15,15, 0, 0
	db	15,15, 0,15, 0,15,15, 0
	db	 0,15,15,15,15, 0,15,15
	db	15, 0, 0,15,15, 0, 0,15
	db	 0,15,15,15, 0, 0,15,15
	db	15,15, 0,15, 0,15,15,15
	db	15,15, 0, 0,15,15, 0,15
	db	 0,15, 0, 0,15,15,15,15
	db	 0,15, 0, 0,15, 0,15,15
	db	15, 0, 0, 0,15, 0, 0, 0
	db	 0,15,15,15,15, 0, 0,15
	db	 0, 0, 0,15,15,15,15,15
	db	 0, 0, 0,15,15, 0, 0,15
	db	15,15, 0, 0,15,15,15, 0
	db	 0, 0, 0, 0,15,15,15,15
	db	15,15, 0, 0,15, 0, 0, 0
	db	 0,15,15, 0, 0,15,15,15
	db	 0,15,15,15, 0, 0,15,15
	db	 0, 0,15,15, 0, 0,15,15
	db	15, 0, 0,15,15, 0,15,15
	db	15,15,15, 0,15, 0, 0,15
	db	 0, 0, 0,15,15, 0, 0, 0
	db	 0, 0,15,15, 0, 0,15,15
	db	15, 0, 0,15,15, 0,15,15
	db	 0, 0, 0, 0,15, 0, 0,15
	db	15,15, 0, 0, 0, 0, 0,15
	db	15, 0, 0,15, 0,15,15, 0
	db	 0, 0,15,15,15, 0, 0, 0
	db	15, 0,15,15, 0, 0, 0,15
	db	 0,15, 0,15,15,15,15,15
	db	15, 0,15,15,15,15, 0, 0
	db	 0, 0,15, 0,15, 0, 0,15
	db	 0,15,15, 0,15,15,15,15
	db	15,15, 0,15, 0, 0, 0, 0
	db	 0, 0,15,15, 0, 0,15,15
	db	15, 0,15, 0,15,15,15, 0
	db	 0,15, 0,15,15, 0, 0, 0
	db	 0, 0, 0, 0, 0, 0, 0,15
	db	 0, 0,15, 0, 0, 0,15, 0
	db	15, 0, 0, 0,15, 0,15,15
	db	 0,15,15, 0, 0,15, 0, 0
	db	 0,15,15, 0,15, 0, 0, 0
	db	15,15,15,15,15, 0,15, 0
	db	 0,15,15, 0,15, 0,15, 0
	db	 0,15, 0,15,15,15,15, 0
	db	 0, 0,15,15, 0, 0, 0, 0
	db	 0,15,15,15, 0, 0,15, 0
	db	 0,15, 0, 0, 0,15, 0,15
	db	 0, 0, 0,15, 0, 0,15, 0
	db	15,15,15,15,15,15, 0, 0
	db	 0, 0,15, 0,15,15, 0, 0
	db	 0, 0, 0, 0, 0, 0, 0,15
	db	15, 0, 0,15, 0,15,15, 0
	db	15,15,15,15,15, 0,15, 0
	db	15, 0, 0, 0,15, 0,15, 0
	db	 0, 0,15, 0,15,15, 0,15
	db	15,15,15,15,15,15, 0,15
	db	15, 0, 0, 0,15,15,15,15
	db	 0, 0, 0, 0,15,15,15,15
	db	15,15,15, 0,15,15, 0,15
	db	 0,15,15,15,15,15, 0,15
	db	15,15,15,15,15, 0,15, 0
	db	15,15, 0,15, 0,15, 0, 0
	db	15,15,15,15,15, 0,15, 0
	db	15,15, 0,15,15, 0,15, 0
	db	15, 0,15, 0,15, 0,15,15
	db	 0, 0,15, 0,15, 0, 0,15
	db	15, 0, 0,15, 0, 0,15, 0
	db	15, 0,15,15,15, 0,15,15
	db	15,15, 0, 0,15,15, 0, 0
	db	15,15,15,15, 0,15, 0,15
	db	15,15,15, 0,15,15, 0,15
	db	15,15,15, 0, 0,15,15, 0
	db	 0,15, 0,15,15, 0, 0, 0
	db	15,15, 0,15,15,15,15,15
	db	 0, 0, 0,15,15,15, 0,15
	db	 0,15, 0, 0, 0, 0, 0,15
	db	 0,15, 0, 0, 0, 0, 0, 0
	db	15,15, 0, 0,15,15, 0,15
	db	15, 0, 0,15,15, 0,15,15
	db	 0, 0,15, 0,15,15, 0,15
	db	15, 0, 0, 0, 0,15,15,15
	db	15,15, 0,15,15,15,15,15
	db	15, 0, 0, 0,15,15,15,15
	db	 0,15,15,15,15, 0,15, 0
	db	15, 0, 0, 0,15,15, 0, 0
	db	 0,15, 0, 0, 0,15,15, 0
	db	15, 0, 0,15, 0, 0,15, 0
	db	 0, 0, 0,15, 0,15, 0,15
	db	15, 0, 0,15,15, 0, 0, 0
	db	15,15,15,15,15, 0,15, 0
	db	15, 0,15,15,15,15,15, 0
	db	 0,15, 0, 0,15,15, 0, 0
	db	 0,15,15, 0,15,15, 0,15
	db	15, 0, 0,15,15,15,15,15
	db	15,15,15, 0, 0, 0,15, 0
	db	15,15,15, 0,15,15, 0,15
	db	15,15,15, 0, 0, 0, 0,15
	db	15, 0, 0,15,15, 0,15, 0
	db	 0,15,15,15,15, 0,15, 0
	db	 0, 0, 0, 0,15, 0,15,15
	db	15, 0, 0,15,15,15,15, 0
	db	 0, 0,15,15,15,15, 0, 0
	db	15,15, 0,15, 0,15, 0,15
	db	15, 0, 0,15,15, 0,15,15
	db	 0, 0, 0, 0, 0,15,15,15
	db	 0,15,15,15, 0, 0,15, 0
	db	 0, 0, 0, 0, 0, 0,15,15
	db	 0,15, 0, 0, 0, 0, 0, 0
	db	15,15, 0, 0, 0,15, 0, 0
	db	 0, 0,15,15, 0, 0, 0, 0
	db	15,15, 0,15, 0, 0, 0,15
	db	15,15, 0,15,15,15,15, 0
	db	 0,15,15,15, 0, 0,15,15
	db	 0,15,15, 0, 0, 0,15,15
	db	 0, 0,15, 0, 0,15,15,15
	db	15, 0,15,15,15, 0,15,15
	db	15, 0,15, 0,15, 0, 0,15
	db	15, 0,15, 0, 0,15, 0,15
	db	 0,15,15,15,15, 0, 0,15
	db	15, 0,15,15,15,15, 0, 0
	db	15,15,15,15, 0, 0, 0,15
	db	 0, 0,15, 0,15,15,15, 0
	db	15, 0, 0,15,15, 0, 0,15
	db	15, 0, 0, 0,15,15,15,15
	db	15,15, 0,15, 0,15,15, 0
	db	 0,15, 0, 0,15,15,15, 0
	db	15, 0,15, 0, 0,15,15,15
	db	15,15,15, 0,15, 0, 0,15
	db	15, 0, 0,15,15, 0, 0,15
	db	 0, 0, 0,15, 0, 0, 0,15
	db	 0, 0, 0, 0,15,15,15, 0
	db	15,15,15,15,15,15,15,15
	db	15, 0,15,15, 0, 0,15,15
	db	15, 0, 0,15,15, 0, 0, 0
	db	15, 0, 0,15,15, 0,15,15
	db	15,15, 0,15,15, 0,15,15
	db	 0,15, 0, 0, 0, 0, 0, 0
	db	 0,15,15, 0, 0, 0,15, 0
	db	15,15,15,15, 0, 0, 0,15
	db	15, 0,15, 0, 0,15,15, 0
	db	15,15, 0,15, 0,15,15, 0
	db	15,15, 0, 0,15,15, 0,15
	db	15, 0,15, 0, 0,15,15,15
	db	15,15, 0,15, 0, 0, 0,15
	db	 0, 0, 0,15, 0,15, 0, 0
	db	15,15, 0, 0, 0,15,15, 0
	db	15,15, 0,15,15,15,15, 0
	db	 0,15,15,15, 0,15,15, 0
	db	 0,15,15,15,15,15,15,15
	db	 0,15,15, 0,15, 0, 0,15
	db	15, 0, 0,15,15, 0,15, 0
	db	15,15,15,15, 0,15, 0, 0

DmaBuf1 db	DMABufSize dup (0)
DmaBuf2 db	DMABufSize dup (0)
ChnlA	db	256 dup (0)
ChnlB	db	256 dup (0)
ChnlC	db	256 dup (0)
ChnlM	db	256 dup (0)
ChnlN	db	256 dup (0)

IF	STEREO
Volume1 db	0,2,3,5,6,8,11,15
	db	21,30,41,53,66,81,98,127
ELSE
Volume1 db	0,1,2,3,4,5,7,10
	db	14,20,27,35,44,54,65,85
ENDIF

ModUp	equ	(Mod1 - Nul) shr 8
ModDown equ	(Mod2 - Nul) shr 8
ModLow	equ	    (Mod3 - Nul) shr 8
ModHi	equ	(Mod4 - Nul) shr 8

Mod1D	db	ModDown, ModLow, ModLow, ModLow ;\___
Mod2D	db	ModUp, ModHi, ModHi, ModHi	;/---
Mod3D	db	ModUp, ModUp, ModUp, ModUp	;////
Mod4D	db	ModDown, ModDown, ModDown, ModDown	;\\\\
Mod5D	db	ModUp, ModDown, ModUp, ModDown	;/\/\
Mod6D	db	ModUp, ModLow, ModLow, ModLow	;/___
Mod7D	db	ModDown, ModHi, ModHi, ModHi	;\---
Mod8D	db	ModDown, ModUp, ModDown, ModUp	;\/\/

ModSel	dw	Mod1D - Nul, Mod1D - Nul, Mod1D - Nul, Mod1D - Nul
	dw	Mod6D - Nul, Mod6D - Nul, Mod6D - Nul, Mod6D - Nul
	dw	Mod4D - Nul, Mod1D - Nul, Mod8D - Nul, Mod7D - Nul
	dw	Mod3D - Nul, Mod2D - Nul, Mod5D - Nul, Mod6D - Nul

;-------------------------------------------------------------------------
;The next is only ZX-Spectrum music player emulator

AyMusicInit:
	xor	ecx,ecx
	xor	edx,edx
	mov	dx,offset MusicData
	jmp	L009
AyMusicPlay:
	xor	ecx,ecx
	xor	edx,edx
	jmp	L144
L009:
	mov	al,[edx]
	mov	[L078],al
	mov	[L0BB],dx
	inc	dx
	call	L0B5
	mov	al,[ecx]
	inc	cx
	inc	al
	mov	[l07a],al
	mov	[l070],cx
	call	l0b5
	mov	[l072],cx
	push	cx
	call	l0b5
	mov	[l074],cx
	mov	dx,001Bh
	call	l0ba
	xchg	cx,dx
	mov	[l076],dx
	mov	dx,offset L081
	mov	[l07b],dx
	mov	dx,offset L082
	mov	cx,offset L083
	mov	bx,002Ch
	mov	[edx],bh
	call	LDIR
	pop	dx
	mov	bx,0021h
	xor	al,al
	call	l0af
	dec	al
	mov	[l08b],al
	mov	[l095],al
	mov	[l09f],al
	mov	al,1
	mov	[l079],al
	inc	dx
	mov	[l089],dx
	mov	[l093],dx
	mov	[l09d],dx
	call	l41f
	ret

L070	dw	0F177h
L072	dw	0F18Fh
L074	dw	0F213h
L076	dw	0EE5Eh
L078	db	06h
L079	db	03h
L07A	db	0Ch
L07B	dw	0F476h
L07D	dw	0F4D2h
L07F	dw	0F50Eh
L081	db	0FFh
L082	db	0
L083	db	0
L084	db	4,0,0
L087	dw	0EE5Fh
L089	    dw	0F190h
L08B	    db	1Ch,2,1
L08E	    db	0Ah,11h,0
L091	    dw	0F04Eh
L093	dw	0F190h
L095	    db	16h,0,1
L098	    db	0Ah,33h,0
L09B	    dw	0F0B1h
L09D	    dw	0F1D2h
L09F	    db	16h
L0A0	    db	05
L0A1	    dw	0EF8h
L0A3	    dw	0594h
L0A5	    dw	0193h
L0A7	db	    0
L0A8	db	31h
L0A9	    db	06
L0AA	db	18h
L0AB	    db	7
L0AC	    db	0B3h,0
L0AE	    db	0

L0AF:
	cmp	al,[edx]
	jz	Return
	add	dx,bx
	jmp	L0AF
L0B5:
	mov	cl,[edx]
	inc	dx
	mov	ch,[edx]
	inc	dx
	xchg	cx,dx
L0BA:
	mov	bx,[L0BB]
	add	dx,bx
	xchg	cx,dx
	ret

L0BB	dw	0EE43h

L0C0:
	mov	ch,0
	mov	cl,al
	add	al,al
	add	al,cl
	mov	cl,al
	add	si,cx
	mov	al,[si+1]
	test	al,80h
	mov	bl,10h
	jnz	L0D3
	mov	bl,ch
L0D3:
	test	al,40h
	mov	bh,2
	jnz	L0DB
	mov	bh,ch
L0DB:
	and	al,1Fh
	mov	dh,al
	mov	cl,[si+2]
	mov	al,[si]
	push	ax
	and	al,0F0h
	ror	al,4
	mov	ch,al
	pop	ax
	and	al,0Fh
	mov	dl,al
	test	[byte ptr si+1],20h
	jz	Return
	or	ch,10h; incorrect
	ret
L0F8:
	mov	al,[L0A0]
	mov	bl,al
	mov	dx,offset L07A
	cmp	al,[edx]
	jc	L105
	xor	al,al
	mov	bl,al
L105:
	inc	al
	mov	[L0A0],al
	mov	dl,bl
	mov	dh,0
	add	dx,dx
	mov	cx,[L070]
	add	dx,cx
	mov	bl,[edx]
	inc	dx
	mov	al,[edx]
	mov	[L344],al
	mov	al,bl
	mov	dx,[L074]
	mov	bx,7
	call	L0AF
	inc	dx
	call	L0B5
	mov	[L07B],cx
	call	L0B5
	mov	[L07D],cx
	call	L0B5
	mov	[L07F],cx
	ret
L139:
	sub	[byte ptr si+2],1
	jnc	Return
	mov	al,[si-1]
	mov	[si+2],al
	ret
L144:
	mov	al,[L079]
	dec	al
	mov	[L079],al
	jnz	L28E
	mov	al,[L078]
	mov	[L079],al
	mov	si,offset L084
	call	L139
	jnc	L16F
	mov	dx,[L07B]
	mov	al,[edx]
	inc	al
	jnz	L1
	call	L0F8
L1:
	mov	dx,[L07B]
	call	L198
	mov	[L07B],dx
L16F:
	mov	si,offset L08E
	call	L139
	jnc	L182
	mov	dx,[L07D]
	call	L198
	mov	[L07D],dx
L182:
	mov	si,offset L098
	call	    L139
	jnc	L28E
	mov	dx,[L07F]
	call	L198
	mov	[L07F],dx
	jmp	L28E
L198:
	mov	al,[edx]
	cmp	al,60h
	jc	L1C6
	cmp	al,70h
	jc	L1D3
	cmp	al,80h
	jc	L1F4
	jz	L1EB
	cmp	al,81h
	jz	L1D1
	cmp	al,82h
	jz	L1F1
	cmp	al,8Fh
	jc	L210
	sub	al,0A1h
	mov	[si+2],al
	mov	[si-1],al
	inc	dx
	jmp	L198
L1C6:
	mov	[si+1],al
	mov	[byte ptr si],0
	mov	[byte ptr si+7],20h
L1D1:
	inc	dx
	ret
L1D3:
	sub	al,60h
	push	dx
	mov	bx,0063h
	mov	dx,[L076]
	call	L0AF
	inc	dx
	mov	[si+3],dl
	mov	[si+4],dh
	pop	dx
	inc	dx
	jmp	L198
L1EB:
	inc	dx
L1EC:
	mov	[byte ptr si+7],0FFh
	ret
L1F1:
	xor	al,al
	jmp	L1F6
L1F4:
	sub	al,70h
L1F6:
	push	dx
	mov	bx,0021h
	mov	dx,[L072]
	call	L0AF
	inc	dx
	mov	[si+5],dl
	mov	[si+6],dh
	mov	[byte ptr si-2],0
	pop	dx
	inc	dx
	jmp	L198
L210:
	sub	al,80h
	mov	[L0AE],al
	inc	dx
	mov	al,[edx]
	inc	dx
	mov	[l0AC],al
	mov	[byte ptr si-2],1
	push	dx
	xor	al,al
	mov	bx,0021h
	mov	dx,[L072]
	call	L0AF
	inc	dx
	mov	[si+5],dl
	mov	[si+6],dh
	pop	dx
	jmp	L198
L235:
	mov	al,[si+7]
	inc	al
	jz	Return
	dec	al
	dec	al
	mov	[si+7],al
	push	ax
	pushf
	mov	al,[si]
	mov	bl,al
	inc	al
	and	al,1Fh
	mov	[si],al
	popf
	pop	ax
	jnz	Return
	mov	cl,[si+3]
	mov	ch,[si+4]
	mov	dx,0060h
	add	dx,cx
	mov	al,[edx]
	sub	al,1
	jc	L1EC
	mov	bl,al
	inc	al
	and	al,1Fh
	mov	[si],al
	inc	dx
	mov	al,[edx]
	inc	al
	mov	[si+7],al
	ret
L269:
	mov	al,bl
	or	al,al
	jnz	Return
	mov	al,dh
	mov	[L0A7],al
	ret
L271:
	mov	al,[si+7]
	inc	al
	jz	Return
	mov	al,[si-2]
	or	al,al
	jz	Return
	cmp	al,2
	jz	L287
	mov	[byte ptr si-2],2
	jmp	L28B
L287:
	xor	al,al
	mov	[L0AE],al
L28B:
	or	[byte ptr edx],10h
	ret
L28E:
	mov	si,offset L084
	call	L235
	mov	al,bl
	mov	[byte ptr L33C],al
	mov	si,[L087]
	call	L0C0
	mov	al,bl
	or	al,bh
	ror	al,1
	mov	[L0A8],al
	mov	si,offset L084
	mov	al,[si+7]
	inc	al
	jz	L2BA
	call	L269
	call	L332
	mov	[L0A1],dx
L2BA:
	mov	dx,offset L0A9
	mov	[edx],al
	call	L271
	mov	si,offset L08E
	call	L235
	mov	al,[si+7]
	inc	al
	jz	L2EF
	mov	al,bl
	mov	[byte ptr L33C],al
	mov	si,[L091]
	call	L0C0
	mov	al,[L0A8]
	or	al,bl
	or	al,bh
	mov	[L0A8],al
	call	L269
	mov	si,offset L08E
	call	L332
	mov	[L0A3],dx
L2EF:
	mov	dx,offset L0AA
	mov	[edx],al
	call	L271
	mov	si,offset L098
	call	L235
	mov	al,[si+7]
	inc	al
	jz	L328
	mov	al,bl
	mov	[byte ptr L33C],al
	mov	si,[L09B]
	call	L0C0
	mov	al,[L0A8]
	rol	bl,1
	rol	bh,1
	or	al,bl
	or	al,bh
	mov	[L0A8],al
	call	L269
	mov	si,offset L098
	call	L332
	mov	[L0A5],dx
L328:
	mov	dx,offset L0AB
	mov	[edx],al
	call	L271
	jmp	L41F

L33C	dw	9h

L332:
	mov	al,dl
	push	ax
	pushf
	push	cx
	mov	dl,[si+5]
	mov	dh,[si+6]
	mov	cx,[L33C]
	add	dx,cx
	mov	al,[si+1]
	add	al,[edx]
	add	al,[L344]
	add	al,al
	mov	cl,al
	mov	ch,0
	mov	dx,offset L35F
	add	dx,cx
	mov	cl,[edx]
	inc	edx
	mov	ch,[edx]
	xchg	cx,dx
	pop	cx
	popf
	pop	ax
	test	ch,10h
	jz	L35B
	and	ch,0EFh
	add	dx,cx
	ret
L35B:
	sub	dx,cx
	ret

L344	db	0
L35F	dw	0EF8h,0E10h,0D60h,0C80h,0BD8h,0B28h,0A88h,09F0h
	dw	0960h,08E0h,0858h,07E0h,077Ch,0708h,06B0h,0640h
	dw	05ECh,0594h,0544h,04F8h,04B0h,0470h,042Ch,03F0h
	dw	03BEh,0384h,0358h,0320h,02F6h,02CAh,02A2h,027Ch
	dw	    0258h,0238h,0216h,01F8h,01DFh,01C2h,01ACh,0190h
	dw	017Bh,0165h,0151h,013Eh,012Ch,011Ch,010Bh,00FCh
	dw	00EFh,00E1h,00D6h,00C8h,00BDh,00B2h,00A8h,009Fh
	dw	0096h,008Eh,0085h,007Eh,0077h,0070h,006Bh,0064h
	dw	005Eh,0059h,0054h,004Fh,004Bh,0047h,0042h,003Fh
	dw	003Bh,0038h,0035h,0032h,002Fh,002Ch,002Ah,0027h
	dw	0025h,0023h,0021h,001Fh,001Dh,001Ch,001Ah,0019h
	dw	0017h,0016h,0015h,0013h,0012h,0011h,0010h,000Fh

L41F:
	mov	si,offset L0AE
	mov	di,offset AyRegs + 13
	mov	cx,14
	xor	al,al
	or	al,[si]
	jnz	L42D
	sub	cx,3
	sub	si,3
	sub	di,3
L42D:
	mov	al,[si]
	mov	[di],al
	dec	si
	dec	di
	dec	cx
	jnz	L42D
	ret





Return:
	ret
LDIR:
	mov	ah,[edx]
	mov	[ecx],ah
	inc	dx
	inc	cx
	dec	bx
	jnz	Short LDIR
	ret

MusicData:

	Ends	Code
        end     Start
